<?php

namespace Objectiv\Plugins\Checkout\Compatibility\Plugins;

use Objectiv\Plugins\Checkout\Compatibility\CompatibilityAbstract;

class OrderDeliveryDate extends CompatibilityAbstract {
	private $is_list_view = null;

	public function is_available(): bool {
		return class_exists( '\\order_delivery_date' );
	}

	public function pre_init() {
		add_filter( 'orddd_shopping_cart_hook', array( $this, 'set_delivery_field_hook' ) );
		add_filter( 'pre_run_through_cfw_form_field', array( $this, 'pre_run_through_cfw_form_field' ), 10, 3 );
	}

	public function pre_run_through_cfw_form_field( $result, $html, $key ) {
		if ( $this->is_list_view ?? $this->get_is_list_view() ) {
			return 'orddd_time_slot' === $key ? $html : $result;
		}
	}

	public function get_is_list_view() {
		$this->is_list_view = get_option( 'orddd_time_slots_in_list_view', '' );

		return $this->is_list_view;
	}

	public function set_delivery_field_hook( $hook ) {
		return 'cfw_checkout_after_shipping_methods';
	}

	public function typescript_class_and_params( array $compatibility ): array {
		$compatibility[] = array(
			'class'  => 'OrderDeliveryDate',
			'params' => array(),
		);

		return $compatibility;
	}
}
