class Utilities {
    public static getComponentValueByType( type: string, components: google.maps.GeocoderAddressComponent[] ): string {
        return components.find( ( { types } ) => types[ 0 ] === type )?.short_name ?? '';
    }

    public static getFirstComponentValueByType( types: Array<string>, components: google.maps.GeocoderAddressComponent[] ): string {
        const values = types.map( ( type ) => Utilities.getComponentValueByType( type, components ) );

        return values.find( ( value ) => value !== '' ) ?? '';
    }
}

export default Utilities;
